#include <stdlib.h>
#include <string.h>
#include <stdio.h>
using namespace std;

static wchar_t *tempString = NULL;

const wchar_t *ctq(const wchar_t *preString, const char *text)
{
    if(tempString != NULL)
        delete[] tempString;
    tempString = new wchar_t[wcslen(preString)+strlen(text)+5];
    swprintf(tempString, L"%s %S", preString, text);
    return tempString;
}

const wchar_t *ctq(const wchar_t *preString, const wchar_t *text)
{
    if(tempString != NULL)
        delete[] tempString;
    tempString = new wchar_t[wcslen(preString)+wcslen(text)+5];
    swprintf(tempString, L"%s %s", preString, text);
    return tempString;
}

const wchar_t *ctq(const wchar_t *preString, const int num)
{
    if(tempString != NULL)
        delete[] tempString;
    tempString = new wchar_t[wcslen(preString)+35];
    swprintf(tempString, L"%s %d", preString, num);
    return tempString;
}

const wchar_t *ctq(const wchar_t *preString, const unsigned int num)
{
    if(tempString != NULL)
        delete[] tempString;
    tempString = new wchar_t[wcslen(preString)+35];
    swprintf(tempString, L"%s %u", preString, num);
    return tempString;
}

const wchar_t *ctq(const wchar_t *preString, const long num)
{
    if(tempString != NULL)
        delete[] tempString;
    tempString = new wchar_t[wcslen(preString)+35];
    swprintf(tempString, L"%s %ld", preString, num);
    return tempString;
}

const wchar_t *ctq(const wchar_t *preString, const unsigned long num)
{
    if(tempString != NULL)
        delete[] tempString;
    tempString = new wchar_t[wcslen(preString)+35];
    swprintf(tempString, L"%s %lu", preString, num);
    return tempString;
}

const wchar_t *ctq(const wchar_t *preString, const double num)
{
    if(tempString != NULL)
        delete[] tempString;
    tempString = new wchar_t[wcslen(preString)+35];
    swprintf(tempString, L"%s %f", preString, num);
    return tempString;
}

const wchar_t *ctq(const wchar_t *preString, const bool b)
{
    if(tempString != NULL)
        delete[] tempString;
    tempString = new wchar_t[wcslen(preString)+10];
    if(b)
        swprintf(tempString, L"%s TRUE", preString);
    else
        swprintf(tempString, L"%s FALSE", preString);
    return tempString;
}
